/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: setTagOperationDispatcher.hxx
    Module  : extensionframework

    This is the root interface class of the setTagOperationDispatcher. It contains of all the generic methods
    for setTagOperationDispatcher that can be reused by the derived classes.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef setTagOperationDispatcher_HXX
#define setTagOperationDispatcher_HXX

#include <extensionframework/PropOperationDispatcher.hxx>
#include <extensionframework/libextensionframework_exports.h>

namespace Teamcenter
{
    class setTagOperationDispatcher;
    class PropOperationDispatcher;
}

class EXTENSIONFRAMEWORK_API Teamcenter::setTagOperationDispatcher : public Teamcenter::PropOperationDispatcher
{
    public:
        setTagOperationDispatcher();
        virtual ~setTagOperationDispatcher();
        static OperationDispatcher *constructor();

    void executePreConditions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePreActions( METHOD_message_t &  msg,  va_list  args ) const;
    void executePostActions( METHOD_message_t &  msg,  va_list  args ) const;

    void setTagPreConditions( Teamcenter::BusinessObject* obj, const tag_t tagValue, const bool isNull ) const;
    void setTagPreActions( Teamcenter::BusinessObject* obj, const tag_t tagValue, const bool isNull ) const;
    void setTagBaseAction( Teamcenter::BusinessObject* obj, const tag_t tagValue, const bool isNull ) const;
    void setTagPostActions( Teamcenter::BusinessObject* obj, const tag_t tagValue, const bool isNull ) const;

    // Project 011450 changes
    void setTagPreConditions( METHOD_message_t* msgData, const tag_t tagValue, const logical isNull ) const;
    void setTagPreActions( METHOD_message_t* msgData, const tag_t tagValue, const logical isNull ) const;
    void setTagPostActions( METHOD_message_t* msgData, const tag_t tagValue, const logical isNull ) const;
    void setTagBaseAction( METHOD_message_t* msgData, const tag_t tagValue, const logical isNull ) const;


    void setTag( Teamcenter::BusinessObject* obj, const tag_t tagValue, const bool isNull ) const;

    void execute(Teamcenter::BusinessObject* obj, std::vector<void*>&  args ) const;
    void execute( tag_t objTag, va_list  args ) const;
    void execute( Teamcenter::BusinessObject* obj,  va_list  args  ) const;


    //Fix compiler warnings that were hiding virtual functions
    using Teamcenter::OperationDispatcher::executePreConditions;
    using Teamcenter::OperationDispatcher::executePreActions;
    using Teamcenter::OperationDispatcher::executePostActions;

};

#include <extensionframework/libextensionframework_undef.h>
#endif //setTagOperationDispatcher_HXX
